config/routes.rb
Rails.application.routes.draw do
  root 'learning_resources#index'  
  resources :quiz_transactions
  resources :learning_resource_transactions
  resources :quiz_questions
  resources :learning_resources
  devise_for :users

  resources :quizzes do
    resources :questions
  end

  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check
  
  # Defines the root path route ("/")
  # root "posts#index"
end

app/controllers/learning_resource_transactions_controller.rb
class LearningResourceTransactionsController < ApplicationController
  before_action :set_learning_resource_transaction, only: %i[ show edit update destroy ]

  # GET /learning_resource_transactions or /learning_resource_transactions.json
  def index
    @learning_resource_transactions = LearningResourceTransaction.all
  end

  # GET /learning_resource_transactions/1 or /learning_resource_transactions/1.json
  def show
  end

  # GET /learning_resource_transactions/new
  def new
    @learning_resource_transaction = LearningResourceTransaction.new
  end

  # GET /learning_resource_transactions/1/edit
  def edit
  end

  # POST /learning_resource_transactions or /learning_resource_transactions.json
  def create
    @learning_resource_transaction = LearningResourceTransaction.new(learning_resource_transaction_params)

    respond_to do |format|
      if @learning_resource_transaction.save
        format.html { redirect_to learning_resource_transaction_url(@learning_resource_transaction), notice: "Learning resource transaction was successfully created." }
        format.json { render :show, status: :created, location: @learning_resource_transaction }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @learning_resource_transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /learning_resource_transactions/1 or /learning_resource_transactions/1.json
  def update
    respond_to do |format|
      if @learning_resource_transaction.update(learning_resource_transaction_params)
        format.html { redirect_to learning_resource_transaction_url(@learning_resource_transaction), notice: "Learning resource transaction was successfully updated." }
        format.json { render :show, status: :ok, location: @learning_resource_transaction }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @learning_resource_transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /learning_resource_transactions/1 or /learning_resource_transactions/1.json
  def destroy
    @learning_resource_transaction.destroy!

    respond_to do |format|
      format.html { redirect_to learning_resource_transactions_url, notice: "Learning resource transaction was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_learning_resource_transaction
      @learning_resource_transaction = LearningResourceTransaction.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def learning_resource_transaction_params
      params.fetch(:learning_resource_transaction, {})
    end
end

app/helpers/learning_resource_transactions_helper.rb
module LearningResourceTransactionsHelper
end

app/views/learning_resource_transactions/_form.html.erb
<%= form_with(model: learning_resource_transaction) do |form| %>
  <% if learning_resource_transaction.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(learning_resource_transaction.errors.count, "error") %> prohibited this learning_resource_transaction from being saved:</h2>

      <ul>
        <% learning_resource_transaction.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/learning_resource_transactions/_learning_resource_transaction.html.erb
<!-- app/views/devise/registrations/new.html.erb -->

<%= form_for(resource, as: resource_name, url: registration_path(resource_name)) do |f| %>
  <!-- other registration fields -->

  <% if current_user&.admin? %>
    <div class="field">
      <%= f.label :role %><br />
      <%= f.select :role, User.roles.keys.map { |role| [role.titleize, role] }, {}, { class: 'select' } %>
    </div>
  <% end %>

  <!-- more code... -->
<% end %>

app/views/learning_resource_transactions/edit.html.erb
<h1>Editing learning resource transaction</h1>

<%= render "form", learning_resource_transaction: @learning_resource_transaction %>

<br>

<div>
  <%= link_to "Show this learning resource transaction", @learning_resource_transaction %> |
  <%= link_to "Back to learning resource transactions", learning_resource_transactions_path %>
</div>

app/views/learning_resource_transactions/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Learning resource transactions</h1>

<div id="learning_resource_transactions">
  <% @learning_resource_transactions.each do |learning_resource_transaction| %>
    <%= render learning_resource_transaction %>
    <p>
      <%= link_to "Show this learning resource transaction", learning_resource_transaction %>
    </p>
  <% end %>
</div>

<%= link_to "New learning resource transaction", new_learning_resource_transaction_path %>

app/views/learning_resource_transactions/new.html.erb
<h1>New learning resource transaction</h1>

<%= render "form", learning_resource_transaction: @learning_resource_transaction %>

<br>

<div>
  <%= link_to "Back to learning resource transactions", learning_resource_transactions_path %>
</div>

app/views/learning_resource_transactions/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @learning_resource_transaction %>

<div>
  <%= link_to "Edit this learning resource transaction", edit_learning_resource_transaction_path(@learning_resource_transaction) %> |
  <%= link_to "Back to learning resource transactions", learning_resource_transactions_path %>

  <%= button_to "Destroy this learning resource transaction", @learning_resource_transaction, method: :delete %>
</div>